import java.io.*;
import java.util.*;
import java.util.stream.*;
import jp.ac.kobe_u.cs.cream.*;

public class AddAB extends Object
{
	public Integer GetIntValue(Solution sol, Network net, String nm)
	{
		List<Variable> val_al = net.getVariables();
		for(Variable val: val_al){
			if(val.getName().equals(nm))
				return Integer.valueOf( sol.getIntValue((IntVariable)val) );
		}
		return null;
	}
	public AddAB()
	{
		Network net = new Network();
		IntVariable a = new IntVariable(net, 1, 9, "a");
		IntVariable b = new IntVariable(net, 1, 9, "b");
		a.add(b).equals(10);
		System.out.println("Problem:");
		System.out.println(net);
		System.out.println("Solution:");
		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		ArrayList<Integer[]> ans_al = new ArrayList<>();
		for(solver.start(); solver.waitNext(); solver.resume()){
			sol = solver.getSolution();
			Integer[] ary = new Integer[2];
			ary[0] = GetIntValue(sol, net, "a");
			ary[1] = GetIntValue(sol, net, "b");
			ans_al.add(ary);
		}
		solver.stop();
		ans_al.stream()
		.map(ary->{
			return "(" + ary[0] + "," + ary[1] + ")";
		}).forEach(System.out::println);
	}
	public static void main(String... args)
	{
		AddAB app = new AddAB();
	}
}

