// HelloZ3.java
// (a or b) and c
import com.microsoft.z3.*;
import java.util.HashMap;
/**
HelloZ3 NX: ߂ĂZ3(ɂZ3)
@author Toshihiro MORISAWA
@version 1.0
*/
public class HelloZ3
{
  /**
  C\bh
  @param args R}hC
  @return Ȃ
  */
  @SuppressWarnings("unchecked")
  public static void main(String... args)
  {
    Context context = new Context(new HashMap<>());
    BoolExpr a = context.mkBoolConst("a");
    BoolExpr b = context.mkBoolConst("b");
    BoolExpr c = context.mkBoolConst("c");
    BoolExpr formula = context.mkAnd(context.mkOr(a,b),c);
    Solver solver = context.mkSolver();
    solver.add(formula);
    if(solver.check()==Status.SATISFIABLE){
      Model model = solver.getModel();
      Expr resultVa = model.eval(a, false);
      Expr resultVb = model.eval(b, false);
      Expr resultVc = model.eval(c, false);
      System.out.println("(a,b,c)=(" + resultVa + "," + resultVb + "," + resultVc + ")");
    }
  }
}
