# 4.2 transport
from mip import *

prob = Model(sense=MINIMIZE, solver_name=CBC)
x = [[prob.add_var(name='x_{}_{}'.format(i+1,j+1), var_type=CONTINUOUS, lb=0) for j in range(4)] for i in range(3)]
A = [[10,2,5,3],[2,1,8,5],[4,8,1,2]]
b = [100,100,100]
c = [80,90,50,80]
xo = [x[i][j] for i in range(3) for j in range(4)]
ao = [A[i][j] for i in range(3) for j in range(4)]
prob += xsum(aoi*xoi for aoi, xoi in zip(ao,xo))
for i in range(3):
  prob += xsum(xj for xj in x[i]) <= b[i], 'const_b{}'.format(i)
for j in range(4):
  prob += xsum(xi for xi in [x[i][j] for i in range(3)]) == c[j], 'const_c{}'.format(j)

print('objective:',prob.objective)
for i in range(3):
  print(prob.constr_by_name('const_b{}'.format(i)))
for j in range(4):
  print(prob.constr_by_name('const_c{}'.format(j)))
  
status = prob.optimize()
print('Status', status)
for i in range(3):
  for j in range(4):
    print('x_{}_{}'.format(i+1,j+1), prob.vars['x_{}_{}'.format(i+1,j+1)].x)
print('objective:', prob.objective_value)
