
from pulp import *
prob = LpProblem(name='production', sense=LpMinimize)
x_plus = [LpVariable('xp{}'.format(i), lowBound=0, cat='Continuous') for i in range(3)]
x_minus = [LpVariable('xm{}'.format(i), lowBound=0, cat='Continuous') for i in range(3)]
A = [[3, 9, 4], [6, 5, 8], [7, 11, 8]]
b = [425, 300, 500]
c = [4, 7, 5]

prob += lpDot(x_plus, c)+lpDot(x_minus, c), 'objective_function'
for i in range(3):
  prob += lpDot(x_plus, A[i]) - lpDot(x_minus, A[i]) == b[i], 'constraint{}'.format(i)

print(prob)
status = prob.solve()
print('Status', LpStatus[status])
print('Result')
for i in range(3):
  print(x_plus[i].name, x_plus[i].value())
for i in range(3):
  print(x_minus[i].name, x_minus[i].value())
print('obj', prob.objective.value())

