# 4.4 fraction
from mip import *

prob = Model(sense=MINIMIZE, solver_name=CBC)
y = [prob.add_var(name='y{}'.format(i), var_type=CONTINUOUS, lb=0) for i in range(3)]
t = prob.add_var(name='t', var_type=CONTINUOUS, lb=0)
A = [[1,2,-1],[-4,1,1],[3,-1,1]]
b = [3,2,1]
c = [3,2,2]
c0 = 4
d = [1,4,2]
d0 = 3
prob += xsum(ci*yi for ci,yi in zip(c,y)) + c0*t, 'objective_function'
prob += xsum(di*yi for di,yi in zip(d,y)) + d0*t == 1, 'const_d'
for i in range(3):
  prob += xsum(ai*yi for ai,yi in zip(A[i],y)) - b[i]*t == 0, 'const_a{}'.format(i)

print('objective:',prob.objective)
print(prob.constr_by_name('const_d'))
for i in range(3):
  print(prob.constr_by_name('const_a{}'.format(i)))

status = prob.optimize()
print('Status', status)
print('t:', prob.vars['t'].x)
t_val = prob.vars['t'].x
y_val = np.zeros(3)
for i in range(3):
  print('y{}'.format(i), prob.vars['y{}'.format(i)].x)
  y_val[i] = prob.vars['y{}'.format(i)].x
print('objective:', prob.objective_value)
x_val = y_val/t_val
print('x:', x_val)
