#min-maxで投資判断
#２つの銘柄0,1で、投資x0,x1を合わせて100万円
#景気は後退状況であって、1年後の収益予測は(1-c0),(1-c1)倍
#損失分は別途補填されるので、損失を最小化することを目的とする。
#予測は４パターンが想定されて、最悪の場合でも、損失が最も小さい投資をしたい
from mip import *
import numpy as np

prob = Model(sense=MINIMIZE, solver_name=CBC)
x = [prob.add_var(name='x{}'.format(i), var_type=CONTINUOUS, lb=0) for i in range(2)]
lbd = prob.add_var(name='lbd', var_type=CONTINUOUS)
A = [1,1]
b = [100]
c = [
  [0.2,0.3],
  [0.1,0.1],
  [-0.4,0.5],
  [0.4,-0.3]
  ]
#prob += lbd
prob.objective=minimize(lbd)
for i in range(4):
  prob += xsum(cj*xj for cj,xj in zip(c[i],x)) <= lbd, 'const_l{}'.format(i)
prob += xsum(ai*xi for ai,xi in zip(A,x)) == b[0], 'const_a'

print('objective:',prob.objective)
print(prob.constr_by_name('const_a'))
for i in range(4):
  print(prob.constr_by_name('const_l{}'.format(i)))

status = prob.optimize()
print('Status', status)
print('λ:', prob.vars['lbd'].x)
x_val = np.zeros(2)
for i in range(2):
  print('x{}'.format(i), prob.vars['x{}'.format(i)].x)
  x_val[i] = prob.vars['x{}'.format(i)].x
print('objective:', prob.objective_value)
for i in range(4):
  print('予想損失', i, ':', c[i][0]*x_val[0]+c[i][1]*x_val[1])
