from mip import *
prob = Model(sense=MINIMIZE, solver_name=CBC)
x = [prob.add_var(name='x_{}'.format(i), var_type=CONTINUOUS, lb=-1.0E10) for i in range(3)]
A = [[1, 2, 3], [5, 2, 8], [1, 3, 5]]
b = [3, 2, 5]
e = [prob.add_var(name='e_{}'.format(i), var_type=CONTINUOUS, lb=0) for i in range(3)]

for i in range(3):
  prob += xsum(xi*ai for xi,ai in zip(x,A[i])) + e[i] == b[i], 'constraint{}'.format(i)

prob += xsum(ei for ei in e)

for i in range(3):
  print(prob.constr_by_name('constraint{}'.format(i)))

print('objective:', prob.objective)

status = prob.optimize()
print('Status', status)
for i in range(3):
  print('x_{}'.format(i), prob.vars['x_{}'.format(i)].x)

print('objective:', prob.objective_value)


