
from pulp import *
prob = LpProblem(name='simulataneous_equation', sense=LpMinimize)
x = [LpVariable('x{}'.format(i), cat='Continuous') for i in range(3)]
A = [[1, 2, 3], [5, 2, 8], [1, 3, 5]]
b = [3, 2, 5]

for i in range(3):
  prob += lpDot(x, A[i])== b[i], 'constraint{}'.format(i)

print(prob)
status = prob.solve()
print('Status', LpStatus[status])
print('Result')
for i in range(3):
  print(x[i].name, x[i].value())

if prob.objective==None:
  print('no objective value')
else:
  print('obj', prob.objective.value())

