# 5.4 ビンパッキング
from pulp import *
import numpy as np
n = 10
w = np.array([3.3, 2.5, 1.5, 7.2, 4.1, 8.3, 6.3, 9.2, 3.9, 6.8])
m = 3
prob = LpProblem(name="bin_packing", sense=LpMinimize)
x = [[LpVariable('x_p'+str(j+1)+'_i'+str(i+1), cat='Binary') for i in range(n)] for j in range(m)]
x = np.array(x)
xt = x.transpose()
W = LpVariable('W')
prob += W, 'Objective'
for j in range(m):
  prob += W >= lpDot(w,x[j]), 'each person '+ str(j)
for i in range(n):
  prob += lpSum(xt[i]) == 1, 'item select ' +str(i)
print(prob)
prob.solve()
print(LpStatus[prob.status])
print('Optimal value =', value(prob.objective))
for v in prob.variables():
  print(v.name,'=',v.varValue)


