from pulp import *

prob = LpProblem('edge-coloring', sense=LpMinimize)

nc=10
nn=5
ne=8

z = LpVariable('z', cat='Integer')
y = [LpVariable('y{}'.format(i), cat='Binary') for i in range(nc)]
x = [[LpVariable('x{}_{}'.format(i,j), cat='Binary') for j in range(nc)] for i in range(ne)]
v=[(0,1),(1,2),(0,2),(0,3),(0,5),(3,5),(2,4),(2,7),(4,7),(1,4),(1,6),(1,3),(4,6),(4,3),(6,3),(5,6),(5,7),(6,7)]

prob += z
prob += z==lpSum(y)

for i in range(ne):
  prob += lpSum(x[i])==1

for i in range(ne):
  for j in range(nc):
    prob += x[i][j]<=y[j]

for vv in (v):
  for j in range(nc):
    print(vv[0], vv[1])
    prob += x[vv[0]][j]+x[vv[1]][j]<=1

status = prob.solve()
print('Status', LpStatus[status])
print('color selection:', [y1.value() for y1 in y])
for i in range(ne):
  print('Edge' + str(i) + ':', [x1.value() for x1 in x[i]])
print(prob.objective.value())


