from pulp import *

prob = LpProblem('p-center')
n=5
cost = [
[10,  4, 11,  7, 12],
[ 8,  5,  1, 13,  8],
[ 4, 11,  7, 11,  9],
[ 7,  5,  3,  4, 11],
[ 4,  6, 13,  9, 15],
]

fac = [LpVariable('f{}'.format(i), cat='Binary') for i in range(n)]
x = [[LpVariable('x{}_{}'.format(i,j), cat='Binary') for j in range(n)] for i in range(n)]
z = LpVariable('z', lowBound=0)

prob += z
prob += lpSum(fac) == 3
for c,xx in zip(cost, x):
    prob += lpDot(c,xx) <= z
for i in range(n):
    prob += lpSum(x[i]) == 1
for i in range(n):
    for j in range(n):
        prob += x[i][j] <= fac[j]

status = prob.solve()
print('Status', LpStatus[status])
print([f.value() for f in fac])
for xtmp in x:
    print([xx.value() for xx in xtmp])
print(prob.objective.value())



