from pulp import *

prob = LpProblem('p-median')

n=5
m=3
cost = [
[10,  4, 11,  7, 12],
[ 8,  5,  1, 13,  8],
[ 4, 11,  7, 11,  9],
[ 7,  5,  3,  4,  2],
[ 4,  6, 13,  9,  5],
]

users = [1, 8, 4, 9, 7]

fac = [LpVariable('f{}'.format(i), cat='Binary') for i in range(n)]
x = [[LpVariable('x{}_{}'.format(i,j), cat='Binary') for j in range(n)] for i in range(n)]

prob += lpSum([users[i] * lpDot(cost[i], x[i]) for i in range(n)])

prob += lpSum(fac) == m
for i in range(n):
    prob += lpSum(x[i]) == 1
for i in range(n):
    for j in range(n):
        prob += x[i][j] <= fac[j]

status = prob.solve()
print('Status', LpStatus[status])
print([f.value() for f in fac])
for x1 in x:
    print([x2.value() for x2 in x1])
print(prob.objective.value())


