from pulp import *

prob = LpProblem('node-coloring', sense=LpMinimize)

nc=10
nn=5
ne=8

z = LpVariable('z', cat='Integer')
y = [LpVariable('y{}'.format(i), cat='Binary') for i in range(nc)]
x = [[LpVariable('x{}_{}'.format(i,j), cat='Binary') for j in range(nc)] for i in range(nn)]
e=[(0,1),(0,2),(0,4),(1,3),(1,4),(2,3),(2,4),(3,4)]

prob += z
prob += z==lpSum(y)

for i in range(nn):
  prob += lpSum(x[i])==1

for i in range(nn):
  for j in range(nc):
    prob += x[i][j]<=y[j]

for ee in (e):
  for j in range(nc):
    prob += x[ee[0]][j]+x[ee[1]][j]<=1

status = prob.solve()
print('Status', LpStatus[status])
print('color selection:', [y1.value() for y1 in y])
for i in range(nn):
  print('Node' + str(i) + ':', [x1.value() for x1 in x[i]])
print(prob.objective.value())


