from pulp import *
from math import sqrt
from itertools import product

m = 10  # area: MxM
n = 6   # n_point
M = 100 # big number
def distance(p1,p2):
  return(sqrt((p1[0]-p2[0])**2+(p1[1]-p2[1])**2)/m)

#x = LpVariable.dict(name="x",indexs=(range(m),range(m)),cat='Binary')
idcs=[str(i)+"_"+str(j) for i in range(m) for j in range(m)]

#x = LpVariable.dict(name="x",indexs=(range(m),range(m)),cat='Binary')
x = LpVariable.dict(name="x",indices=idcs,cat='Binary')
z = LpVariable("z", lowBound=0, upBound=M ,cat=LpContinuous)
prob = LpProblem(name="PointLocation",sense=LpMaximize)

prob += z, 'Objective'

#prob += lpSum([x[(i,j)] for i,j in product(range(m),range(m))]) == n, 'the_number_of_points'
prob += lpSum([x[str(i)+"_"+str(j)] for i,j in product(range(m),range(m))]) == n, 'the_number_of_points'

for i,j in product(range(m),range(m)):
  for k,l in product(range(m),range(m)):
    if i!=k or j!=l:
      ij = '(' + str(i) + ',' + str(j) + ')'
      kl = '(' + str(k) + ',' + str(l) + ')'
      #prob += z <= (1-x[(i,j)])*M + (1-x[(k,l)])*M + distance((i,j),(k,l)), 'effective distance ' + ij + ' ' + kl
      prob += z <= (1-x[str(i)+"_"+str(j)])*M + (1-x[str(k)+"_"+str(l)])*M + distance((i,j),(k,l)), 'effective distance ' + ij + ' ' + kl

print(prob)
prob.solve()
print(LpStatus[prob.status])
print('Optimal distance = ', value(prob.objective))

#result = [[int(x[(i,j)].varValue) for i in range(m)] for j in range(m)]
result = [[int(x[str(i)+"_"+str(j)].varValue) for i in range(m)] for j in range(m)]
for l in result: print(l)

