from z3 import *
p1x, p1y, p2x, p2y, p3x, p3y = Ints('p1x p1y p2x p2y p3x p3y')
d12, d23, d31 = Reals('d12 d23 d31')
dd12, dd23, dd31 = Reals('dd12 dd23 dd31')
z = Real('z')
o = Optimize()
o.maximize(z)
o.add(p1x==0, p1y==0)
o.add(p1x>=0, p1y>=0, p2x>=0, p2y>=0, p3x>=0, p3y>=0)
o.add(p1x<=9, p1y<=9, p2x<=9, p2y<=9, p3x<=9, p3y<=9)
o.add(dd12 == (p1x-p2x)**2+(p1y-p2y)**2)
o.add(dd23 == (p2x-p3x)**2+(p2y-p3y)**2)
o.add(dd31 == (p3x-p1x)**2+(p3y-p1y)**2)
o.add(d12**2 == dd12, d23**2 == dd23, d31**2 == dd31)
o.add(d12>=z, d23>=z, d31>=z)
o.add(z>8) # OK
#o.add(z>9) # OK
#o.add(z>10) # NG
o.add(d12>=0, d23>=0, d31>=0)
print(o.check())
print(o.model())