import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;

public class D2_16_4_1 extends Object
{

	public Integer GetIntValue(Solution sol, Network net, String nm)
	{
		List<Variable> val_al = net.getVariables();
		for(Variable val: val_al){
			if(val.getName().equals(nm))
				return Integer.valueOf( sol.getIntValue((IntVariable)val) );
		}
		return null;
	}

	public D2_16_4_1()
	{
		Network net = new Network();
		IntVariable ZERO = new IntVariable(net, 0, "ZERO");
		IntVariable ONE = new IntVariable(net, 1, "ONE");
		IntVariable FOUR = new IntVariable(net, 4, "FOUR");
		IntVariable FIVE = new IntVariable(net, 5, "FIVE");
	
		int n_member = 16;
		int n_table = 4;
		int n_day = 5;	//5;

		IntVariable[][][] plan = new IntVariable[n_member][n_table][n_day];
		for(int i=0; i<n_member; i++){
			for(int j=0; j<n_table; j++){
				for(int k=0; k<n_day; k++){
					String nm = String.format("%02d", i) + "_" + Integer.toString(j) + "_" + Integer.toString(k);
					plan[i][j][k] = new IntVariable(net, 0, 1, nm);
					if(i==0){
						if(j==0)	plan[i][j][k].equals(ONE);
						else	plan[i][j][k].equals(ZERO);
					}else if(i==1){
						if(k<n_day-1)
							if(j==1)	plan[i][j][k].equals(ONE);
							else	plan[i][j][k].equals(ZERO);
					}else if(i==2){
						if(k<n_day-2)
							if(j==2)	plan[i][j][k].equals(ONE);
							else	plan[i][j][k].equals(ZERO);
					}else if(i==3){
						if(k<n_day-3)
							if(j==3)	plan[i][j][k].equals(ONE);
							else	plan[i][j][k].equals(ZERO);
					}
				}
			}
		}
		IntVariable tmp = null;
		
		IntVariable[][] c_attendance = new IntVariable[n_member][n_day];
		for(int i=0; i<n_member; i++){
			for(int k=0; k<n_day; k++){
				String nm = "att_" + String.format("%02d", i) + "_" + Integer.toString(k);
				tmp = null;
				for(int j=0; j<n_table; j++){
					tmp = tmp==null ? plan[i][j][k] : tmp.add(plan[i][j][k]);
				}
				c_attendance[i][k] = tmp;
				c_attendance[i][k].equals(ONE);
				c_attendance[i][k].setName(nm);
			}
		}

		IntVariable[][] c_table = new IntVariable[n_table][n_day];
		for(int j=0; j<n_table; j++){
			for(int k=0; k<n_day; k++){
				String nm = "table_" + Integer.toString(j) + "_" + Integer.toString(k);
				tmp = null;
				for(int i=0; i<n_member; i++){
					tmp = tmp==null ? plan[i][j][k] : tmp.add(plan[i][j][k]);
				}
				c_table[j][k] = tmp;
				c_table[j][k].equals(FOUR);
				c_table[j][k].setName(nm);
			}
		}

		IntVariable[][] c_combination = new IntVariable[n_member][n_member];
		for(int i1=0; i1<n_member; i1++){
			for(int i2=0; i2<n_member; i2++){
				String nm = "comb_" + String.format("%02d", i1) + "_" + String.format("%02d", i2);
				tmp = null;
				for(int j=0; j<n_table; j++){
					for(int k=0; k<n_day; k++){
						tmp = tmp==null ?
							plan[i1][j][k].multiply(plan[i2][j][k]) :
							tmp.add(plan[i1][j][k].multiply(plan[i2][j][k]));
					}
				}
				c_combination[i1][i2] = tmp;
				if(i1==i2){
					c_combination[i1][i2].equals(FIVE);
				}else{
					c_combination[i1][i2].equals(ONE);
				}
				c_combination[i1][i2].setName(nm);
			}
		}

		/*
		int[] num = new int[n_member];
		for(int i=0; i<n_member; i++) num[i] = 1+i;

		IntVariable[][] sum_num = new IntVariable[n_table][n_day];
		String[][] sum_num_s = new String[n_table][n_day];
		for(int j=0; j<n_table; j++){
			for(int k=0; k<n_day; k++){
				String nm = "sum_" + Integer.toString(j) + "_" + Integer.toString(k);
				tmp = null;
				for(int i=0; i<n_member; i++){
					tmp = tmp==null ?
						plan[i][j][k].multiply(num[i]) :
						tmp.add(plan[i][j][k].multiply(num[i]));
				}
				sum_num[j][k] = tmp;
				sum_num[j][k].setName(nm);
				sum_num_s[j][k] = nm;
			}
		}
		
		for(int j=1; j<n_table; j++){
			for(int k=0; k<n_day; k++){
				sum_num[j-1][k].le(sum_num[j][k]);
			}
		}
		*/
		//sum_num[0][0].le(sum_num[1][0]);
		//sum_num[0][1].le(sum_num[1][1]);
		//sum_num[2][0].le(sum_num[3][0]);


		int[] p2 = new int[n_member];
		p2[n_member-1] = 1;
		for(int i=1; i<n_member; i++){
			p2[n_member-1-i] = 2 * p2[n_member-i];
		}
		IntVariable[][] z2 = new IntVariable[n_table][n_day];
		String[][] z2_s = new String[n_table][n_day];
		for(int j=0; j<n_table; j++){
			for(int k=0; k<n_day; k++){
				String nm = "z2_" + Integer.toString(j) + "_" + Integer.toString(k);
				tmp = null;
				for(int i=0; i<n_member; i++){
					tmp = tmp==null ?
						plan[i][j][k].multiply(p2[i]) :
						tmp.add(plan[i][j][k].multiply(p2[i]));
				}
				z2[j][k] = tmp;
				z2[j][k].setName(nm);
				z2_s[j][k] = nm;
			}
		}
		
		for(int j=1; j<n_table; j++){
			//for(int k=0; k<n_day; k++){
			for(int k=0; k<3; k++){
				z2[j-1][k].gt(z2[j][k]);
			}
			//z2[j-1][0].gt(z2[j][0]);
		}
		
		//z2[0][0].gt(z2[1][0]);

		System.out.println("# Problem");
		System.out.println(net);
		System.out.println("# Solution");

		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		int cnt = 0;
		for(solver.start(); solver.waitNext(); solver.resume()){
			cnt++;
			sol = solver.getSolution();
			System.out.println(sol);
			if(cnt>0)	break;
			
			//if(cnt%1000==0) System.out.print(Integer.toString(cnt) + " ");
			System.out.print(Integer.toString(cnt) + " ");
		}
		/*
		for(int k=0; k<n_day; k++){
			for(int j=0; j<n_table; j++){
				System.out.print(sum_num_s[j][k] + ": "  +
					GetIntValue(sol, net, sum_num_s[j][k]) + "\t"
				);
			}
			System.out.println();
		}
		*/
		for(int k=0; k<n_day; k++){
			for(int j=0; j<n_table; j++){
				System.out.print(z2_s[j][k] + ": "  +
					GetIntValue(sol, net, z2_s[j][k]) + "\t"
				);
			}
			System.out.println();
		}
		for(int k=0; k<n_day; k++){
			for(int j=0; j<n_table; j++){
				System.out.println(z2_s[j][k] + ": "  +
					Integer.toBinaryString(GetIntValue(sol, net, z2_s[j][k]))
				);
			}
			System.out.println();
		}


		System.out.println();
		solver.stop();
		long count = solver.getCount();
		long time = solver.getElapsedTime();

		System.out.println(count + " solutions found in " + time + " milli seconds");
	}

	public static void main(String... args)
	{
		D2_16_4_1 app = new D2_16_4_1();
	}
}

