import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;

public class D2_7_3_1 extends Object
{

	public Integer GetIntValue(Solution sol, Network net, String nm)
	{
		List<Variable> val_al = net.getVariables();
		for(Variable val: val_al){
			if(val.getName().equals(nm))
				return Integer.valueOf( sol.getIntValue((IntVariable)val) );
		}
		return null;
	}

	public D2_7_3_1()
	{
		Network net = new Network();
		IntVariable ZERO = new IntVariable(net, 0, "ZERO");
		IntVariable ONE = new IntVariable(net, 1, "ONE");
		IntVariable THREE = new IntVariable(net, 3, "THTREE");
		IntVariable FOUR = new IntVariable(net, 4, "FOUR");
		IntVariable FIVE = new IntVariable(net, 5, "FIVE");
		IntVariable SEVEN = new IntVariable(net, 7, "SEVEN");
	
		int v = 7;
		int k = 3;
		int b = 7;
		int r = 3;
		int l = 1;

		IntVariable[][] p = new IntVariable[v][b];
		for(int i=0; i<v; i++){
			for(int j=0; j<b; j++){
				String nm = "p" + Integer.toString(i) + "_" + Integer.toString(j);
					p[i][j] = new IntVariable(net, 0, 1, nm);
			}
		}
		IntVariable tmp = null;
		
		IntVariable[] p_r = new IntVariable[v];
		for(int i=0; i<v; i++){
			String nm = "rep_" + Integer.toString(i);
			tmp = null;
			for(int j=0; j<b; j++)
				tmp = tmp==null ? p[i][j] : tmp.add(p[i][j]);
			p_r[i] = tmp;
			p_r[i].equals(r);
			p_r[i].setName(nm);
		}
		IntVariable[] b_k = new IntVariable[b];
		for(int i=0; i<b; i++){
			String nm = "block_" + Integer.toString(i);
			tmp=null;
			for(int j=0; j<v; j++)
				tmp = tmp==null ? p[j][i] : tmp.add(p[j][i]);
			b_k[i] = tmp;
			b_k[i].equals(k);
			b_k[i].setName(nm);
		}
		
		IntVariable[][] comb = new IntVariable[v][v];
		for(int i1=0; i1<v; i1++){
			for(int i2=0; i2<v; i2++){
				String nm = "comb_" + Integer.toString(i1) + "_" + Integer.toString(i2);
				tmp = null;
				for(int i=0; i<b; i++)
					tmp = tmp==null ? p[i1][i].multiply(p[i2][i]) : tmp.add(p[i1][i].multiply(p[i2][i]));
				comb[i1][i2] = tmp;
				if(i1==i2)	comb[i1][i2].equals(k);
				else	comb[i1][i2].equals(1);
				comb[i1][i2].setName(nm);
			}
		}

		System.out.println("# Problem");
		System.out.println(net);
		System.out.println("# Solution");

		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		int cnt = 0;
		for(solver.start(); solver.waitNext(); solver.resume()){
			cnt++;
			sol = solver.getSolution();
			System.out.println(sol);
			if(cnt>0)	break;
			
			//if(cnt%1000==0) System.out.print(Integer.toString(cnt) + " ");
			System.out.print(Integer.toString(cnt) + " ");
		}


		System.out.println();
		solver.stop();
		long count = solver.getCount();
		long time = solver.getElapsedTime();

		System.out.println(count + " solutions found in " + time + " milli seconds");
	}

	public static void main(String... args)
	{
		D2_7_3_1 app = new D2_7_3_1();
	}
}

