import java.io.*;
import java.util.*;
import java.util.stream.*;
import jp.ac.kobe_u.cs.cream.*;

public class SLV extends Object
{
	public static IntVariable GV(Network net, String nm)
	{
		List<Variable> var_al = net.getVariables();
		for(Variable var: var_al){
			if(var.getName().equals(nm))
				return (IntVariable)var;
		}
		return null;
	}
	public static IntVariable GetVariable(Network net, String nm)
	{
		List<Variable> var_al = net.getVariables();
		for(Variable var: var_al){
			if(var.getName().equals(nm))
				return (IntVariable)var;
		}
		return null;
	}
	public static Integer GetIntValue(Solution sol, Network net, String nm)
	{
		List<Variable> val_al = net.getVariables();
		for(Variable val: val_al){
			if(val.getName().equals(nm))
				return Integer.valueOf(sol.getIntValue((IntVariable)val));
		}
		return null;
	}

	public static void SOLVE(Network net)
	{
		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		for(solver.start(); solver.waitNext(); solver.resume()){
			sol = solver.getSolution();
			System.out.println(sol);
		}
		solver.stop();
		long count = solver.getCount();
		long time = solver.getElapsedTime();
		System.out.println(count + " solutions found in " + time + " milli seconds.");
	}

	public static ArrayList<Integer[]> SOLVE_RET(Network net, String[] nms)
	{
		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		ArrayList<Integer[]> ans_al = new ArrayList<>();
		for(solver.start(); solver.waitNext(); solver.resume()){
			sol = solver.getSolution();
			Integer[] ary = new Integer[nms.length];
			for(int i=0; i<nms.length; i++){
				ary[i] = GetIntValue(sol, net, nms[i]);
			}
			ans_al.add(ary);
		}
		solver.stop();

		
		return ans_al;
	}

	public static ArrayList<Solution> SOLVE_SOLAL(Network net)
	{
		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		ArrayList<Solution> sol_al = new ArrayList<>();
		for(solver.start(); solver.waitNext(); solver.resume()){
			sol_al.add( solver.getSolution());
		}
		solver.stop();

		return sol_al;
	}

}
