from mip import *
from itertools import product
#from mip import Model, xsum, maximize, BINARY, INTEGER

N=1000
n = 8
c = [1 for _ in range(n)]
m = Model("all_different")
v = [m.add_var('v{}'.format(i), var_type=INTEGER) for i in range(n)]
m.objective = minimize(xsum(c[i] * v[i] for i in range(n)))
x = [[m.add_var("x{}_{}".format(i,j), var_type=BINARY) for i in range(n)] for j in range(n)]

#print(v)
#print(x)

for i in range(n):
  for j in range(n):
    if i==j:
      m += x[i][j]==0
    else:
      m += v[i]+1-v[j]<=N*(1-x[i][j])
      m += v[j]+1-v[i]<=N*x[i][j]
      m += x[i][j]+x[j][i]==1

m.optimize()

for (i,j) in product(range(n), range(n)):
  print('x{}_{}'.format(i,j), x[i][j].x)
for i in range(n):
  print('v{}'.format(i), v[i].x)

