import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;


public class league extends Object
{

	public league()
	{
		int n = 4;	//3;	//10;

		Network net = new Network();

		IntVariable ZERO = new IntVariable(net, 0, "ZERO");
		IntVariable ONE = new IntVariable(net, 1, "ONE");
		IntDomain BD = new IntDomain(0,1);

		IntVariable[][] p = new IntVariable[n][n];

		for(int i=0; i<n; i++){
			for(int j=0; j<n; j++){
				String nm = "p_" + Integer.toString(i) + "_" + Integer.toString(j);
				p[i][j] = new IntVariable(net, BD, nm);
			}
		}

		for(int i=0; i<n; i++)	p[i][i].equals(ZERO);

		for(int i=0; i<n; i++){
			for(int j=i+1; j<n; j++){
				p[i][j].add(p[j][i]).equals(ONE);
			}
		}

		IntVariable[] p_win = new IntVariable[n];
		String[] nms = new String[n];
		for(int i=0; i<n; i++) p_win[i] = null;
		for(int i=0; i<n; i++){
			for(int j=0; j<n; j++){
				p_win[i] = p_win[i]==null ? p[i][j] : p_win[i].add(p[i][j]);
			}
			nms[i] = "p_win_" + Integer.toString(i);
			p_win[i].setName(nms[i]);
		}

		//SLV.SOLVE(net);
		
		ArrayList<Integer[]> ret_al = SLV.SOLVE_RET(net, nms);
		ArrayList<String[]> sorted_al = new ArrayList<>(
			ret_al.stream().map(ret->{
				String[] ss_sort = new String[n];
				for(int i=0; i<n; i++){
					ss_sort[i] = ret[i].toString() + "_" + nms[i];
				}
				ss_sort = Arrays.asList(ss_sort).stream()
				.sorted(Comparator.reverseOrder())
				.collect(Collectors.toList()).toArray(new String[n]);
				return ss_sort;
			}).collect(Collectors.toList())
		);
		sorted_al.stream().forEach(sorted->System.out.println(Arrays.asList(sorted)));

		int[] n_p_win = new int[n];
		for(int i=0; i<n; i++) n_p_win[i] = 0;
		int n_draw = 0;
		for(String[] ss: sorted_al){
			String top = ss[0];
			String[] top_ss = top.split("_", -1);
			String[] nm_ss = new String[top_ss.length-1];
			for(int i=1; i<top_ss.length; i++){
				nm_ss[i-1] = top_ss[i];
			}
			String nm = String.join("_", nm_ss);
			int nw = Integer.valueOf(top_ss[0]).intValue();
			if(nw==n-1){
				for(int i=0; i<n; i++){
					if(nm.equals(nms[i])){
						n_p_win[i]++;
					}
				}
			}else{
				n_draw++;
			}
		}
		for(int i=0; i<n; i++){
			System.out.println(nms[i] + " win: " + Integer.toString(n_p_win[i]));
		}
		System.out.println("draw: " + Integer.toString(n_draw));

	}

	public static void main(String... args)
	{
		league app = new league();
	}
}

