from mip import *
from itertools import product

n=4
num = [i+1 for i in range(n*n)]

m = Model("magic_square")

board = [[[m.add_var("board{}_{}_{}".format(i,j,k), var_type=BINARY) for k in range(n*n)] for j in range(n)] for i in range(n)]
m.objective = minimize(xsum(num[i]*board[0][0][i] for i in range(n*n)))

w = n*(n*n+1)/2

for i in range(n):
  for j in range(n):
    m += xsum(board[i][j][k] for k in range(n*n))==1

for k in range(n*n):
  m += xsum(xsum(board[i][j][k] for i in range(n)) for j in range(n)) == 1

for i in range(n):
  m += xsum(xsum(num[k]*board[i][j][k] for k in range(n*n)) for j in range(n)) == w

for j in range(n):
  m += xsum(xsum(num[k]*board[i][j][k] for k in range(n*n)) for i in range(n)) == w

m += xsum(xsum(num[k]*board[i][i][k] for k in range(n*n)) for i in range(n))==w
m += xsum(xsum(num[k]*board[i][n-1-i][k] for k in range(n*n)) for i in range(n))==w

v = [[m.add_var('v{}_{}'.format(i,j), var_type=INTEGER) for j in range(n)] for i in range(n)]

for i in range(n):
  for j in range(n):
    m += v[i][j] == xsum(num[k]*board[i][j][k] for k in range(n*n))

m += xsum(num[k]*board[0][0][k] for k in range(n*n)) <= xsum(num[k]*board[0][n-1][k] for k in range(n*n))
m += xsum(num[k]*board[0][n-1][k] for k in range(n*n)) <= xsum(num[k]*board[n-1][0][k] for k in range(n*n))
m += xsum(num[k]*board[0][0][k] for k in range(n*n)) <= xsum(num[k]*board[n-1][n-1][k] for k in range(n*n))


m.optimize()

print('v:')
for i in range(n):
  s = str('')
  for j in range(n):
    s = s + str(v[i][j].x) + ' '
  print(s)


