from pulp import *
from itertools import product

n=4
num = [i+1 for i in range(n*n)]

p = LpProblem('magic_square')

board = [[[LpVariable('board{}_{}_{}'.format(i,j,k), cat='Binary') for k in range(n*n)] for j in range(n)] for i in range(n)]

w = n*(n*n+1)/2

for i in range(n):
  for j in range(n):
    p += lpSum(board[i][j][k] for k in range(n*n))==1

for k in range(n*n):
  p += lpSum(lpSum(board[i][j][k] for i in range(n)) for j in range(n)) == 1

for i in range(n):
  p += lpSum(lpSum(num[k]*board[i][j][k] for k in range(n*n)) for j in range(n)) == w

for j in range(n):
  p += lpSum(lpSum(num[k]*board[i][j][k] for k in range(n*n)) for i in range(n)) == w

p += lpSum(lpSum(num[k]*board[i][i][k] for k in range(n*n)) for i in range(n))==w
p += lpSum(lpSum(num[k]*board[i][n-1-i][k] for k in range(n*n)) for i in range(n))==w

v = [[LpVariable('v{}_{}'.format(i,j), cat='Integer') for j in range(n)] for i in range(n)]

for i in range(n):
  for j in range(n):
    p += v[i][j] == lpSum(num[k]*board[i][j][k] for k in range(n*n))

p += lpSum(num[k]*board[0][0][k] for k in range(n*n)) <= lpSum(num[k]*board[0][n-1][k] for k in range(n*n))
p += lpSum(num[k]*board[0][n-1][k] for k in range(n*n)) <= lpSum(num[k]*board[n-1][0][k] for k in range(n*n))
p += lpSum(num[k]*board[0][0][k] for k in range(n*n)) <= lpSum(num[k]*board[n-1][n-1][k] for k in range(n*n))

print(p)
status=p.solve()
print('Status', LpStatus[status])

print('v:')
for i in range(n):
  s = str('')
  for j in range(n):
    s = s + str(v[i][j].value()) + ' '
  print(s)


