# 6.11 nurce
from pulp import *
prob = LpProblem(name='nurce', sense=LpMinimize)
nn = 7 # number of nurce
nd = 7 # number of days
ns = 3 # number of shift, {morning, afternoon, night}
shift = 15
N = [LpVariable('N{}'.format(i), lowBound=0, cat='Integer') for i in range(nn)]
NN = LpVariable('NN', lowBound=0, cat='Integer')
for i in range(nn):
  prob += N[i]<=NN
prob += NN
x = [[[LpVariable('{}_{}_{}'.format(i,j,k), lowBound=0, upBound=1, cat='Binary') for k in range(ns)] for j in range(nd)] for i in range(nn)]

for i in range(nn):
  prob += N[i]==lpSum([lpSum([x[i][j][k] for k in range(ns)]) for j in range(nd)])

for i in range(nn):
  for j in range(nd):
    prob += lpSum([x[i][j][k] for k in range(ns)]) <= 1, 'shift_per_day_{}_{}'.format(i,j)

for k in range(ns):
  prob += lpSum([lpSum([x[i][j][k] for j in range(nd)]) for i in range(nn)]) >= shift

#for j in range(nd):
#  for k in range(ns):
#    prob += lpSum([x[i][j][k] for i in range(nn)]) >= 2

print(prob)
prob.solve()
print('Optimal value = ', value(prob.objective))
for v in prob.variables():
  print(v.name, '=', v.varValue)
