import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;
import java.math.*;

import jp.ac.kobe_u.cs.cream.*;

public class orth_latin_square extends Object
{
	public orth_latin_square()
	{
		int n = 4;

		Network net = new Network();

		IntVariable[][] x = new IntVariable[n][n];
		IntVariable[][] y = new IntVariable[n][n];
		for(Integer I=0; I<n; I++){
			for(Integer J=0; J<n; J++){
				String x_nm = "x_" + I.toString() + "_" + J.toString(); 
				//x[I][J] = new IntVariable(net, 1, n, x_nm);
				//y[I][J] = new IntVariable(net, 1, n, y_nm);
				x[I][J] = new IntVariable(net, 0, n-1, x_nm);
			}
		}
		for(Integer I=0; I<n; I++){
			for(Integer J=0; J<n; J++){
				String y_nm = "y_" + I.toString() + "_" + J.toString(); 
				y[I][J] = new IntVariable(net, 0, n-1, y_nm);
			}
		}
		
		x[0][0].equals(0);
		x[0][0].lt(x[0][n-1]);
		x[0][n-1].lt(x[n-1][0]);
		x[0][0].lt(x[n-1][n-1]);
		y[0][0].equals(0);

		IntVariable[][] x_row = new IntVariable[n][n];
		IntVariable[][] x_col = new IntVariable[n][n];
		IntVariable[][] y_row = new IntVariable[n][n];
		IntVariable[][] y_col = new IntVariable[n][n];
		for(Integer I=0; I<n; I++){
			for(Integer J=0; J<n; J++){
				x_row[I][J] = x[I][J];
				x_col[J][I] = x[I][J];
				y_row[I][J] = y[I][J];
				y_col[J][I] = y[I][J];
			}
		}
		for(Integer I=0; I<n; I++){
			new NotEquals(net, x_row[I]);
			new NotEquals(net, x_col[I]);
			new NotEquals(net, y_row[I]);
			new NotEquals(net, y_col[I]);
		}

		IntVariable[] idx =  new IntVariable[n*n];
		/*
		//IntVariable[] num =  new IntVariable[n*n];
		for(Integer I=0; I<n*n; I++){
			//String num_nm = "num_" + I.toString();
			idx[I] = new IntVariable(net, 0, n*n-1, idx_nm);
			//num[I] = new IntVariable(net, I.intValue(), num_nm);
		}
		*/
		for(Integer I=0; I<n; I++){
			for(Integer J=0; J<n; J++){
				String idx_nm = "idx_" + I.toString() + "_" + J.toString();
				idx[I*n+J] = x[I][J].multiply(n).add(y[I][J]);
				idx[I*n+J].setName(idx_nm);
			}
		}
		new NotEquals(net, idx);
		

		System.out.println("# Problem");
		System.out.println(net);
		System.out.println("# Solution");
		Solver solver = new DefaultSolver(net);
		Solution sol = null;
		int cnt = 0;
		for(solver.start(); solver.waitNext(); solver.resume()){
			cnt++;
			sol = solver.getSolution();
			System.out.println(sol);
			//if(cnt>0)  break;
		}

		solver.stop();
		long count = solver.getCount();
		long time = solver.getElapsedTime();

		System.out.println(count + " solutions found in " + time + " milli seconds");
	}

	public static void main(String... args)
	{
		orth_latin_square app = new orth_latin_square();
	}
}






