from pulp import *

# A  B  C  D  E  F  G  H  I
ws = [
[ 0, 1, 0, 1, 0, 0, 0, 0, 0],   # A
[ 1, 0, 1, 0, 1, 0, 0, 0, 0],   # B
[ 0, 1, 0, 0, 0, 1, 0, 0, 0],   # C
[ 1, 0, 0, 0, 1, 0, 1, 0, 0],   # D
[ 0, 1, 0, 1, 0, 1, 0, 1, 0],   # E
[ 0, 0, 1, 0, 1, 0, 0, 0, 1],   # F
[ 0, 0, 0, 1, 0, 0, 0, 1, 0],   # G
[ 0, 0, 0, 0, 1, 0, 1, 0, 1],   # H
[ 0, 0, 0, 0, 0, 1, 0, 1, 0]    # I
]

node = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I']
size = len(node)
start = 0
goal = 8

prob = LpProblem('hamilton1')

xs = []
for i in range(size):
    xs1 = [LpVariable('x{}_{}'.format(i,j), cat='Binary') for j in range(size)]
    xs.append(xs1)

us = [LpVariable('u{}'.format(i), cat='Integer', lowBound=0, upBound=size-1) for i in range(size)]

prob += lpSum(xs[start]) == 1
prob += lpSum([xs[i][goal] for i in range(size)]) == 1
for i in range(size):
    if i==start or i==goal: continue
    prob += lpSum([xs[j][i] for j in range(size)]) == 1
    prob += lpSum([xs[i][j] for j in range(size)]) == 1

for i in range(size):
    for j in range(size):
        if ws[i][j] == 0: prob += xs[i][j] == 0

for i in range(size):
    for j in range(1, size):
        if i==j: continue
        prob += us[i] + 1 - (size - 1) * (1 - xs[i][j]) <= us[j]
prob += us[0] == 0

status = prob.solve()
print('Status', LpStatus[status])
for i in range(size):
    for j in range(size):
        if xs[i][j].value() == 1:
            print('{} -> {}'.format(node[i], node[j]))
print([u.value() for u in us])





