from pulp import *

prob = LpProblem('max-flow', sense=LpMaximize)

xab = LpVariable('xab', lowBound=0, upBound=5)
xac = LpVariable('xac', lowBound=0, upBound=2)
xbc = LpVariable('xbc', lowBound=0, upBound=6)
xbd = LpVariable('xbd', lowBound=0, upBound=4)
xcd = LpVariable('xcd', lowBound=0, upBound=2)
xce = LpVariable('xce', lowBound=0, upBound=3)
xde = LpVariable('xde', lowBound=0, upBound=3)
xdf = LpVariable('xdf', lowBound=0, upBound=1)
xef = LpVariable('xef', lowBound=0, upBound=9)

prob += xab + xac

prob += xab == xbc + xbd
prob += xac + xbc == xcd + xce
prob += xbd + xcd == xde + xdf
prob += xce + xde == xef

status = prob.solve()
print('Status', LpStatus[status])
print('xab =', xab.value())
print('xac =', xac.value())
print('xbc =', xbc.value())
print('xbd =', xbd.value())
print('xcd =', xcd.value())
print('xce =', xce.value())
print('xde =', xde.value())
print('xdf =', xdf.value())
print('xef =', xef.value())
print('f', prob.objective.value())

