from pulp import *

prob = LpProblem('matching', sense=LpMaximize)

es1 = ['sa', 'sb', 'sc', 'sd', 'se']
es2 = ['av', 'aw', 'ax', 'bv', 'by', 'bz', 'cv', 'cw', 'dx', 'dy', 'dz', 'ev']
es3 = ['vt', 'wt', 'xt', 'yt', 'zt']

xs = {e: LpVariable(e, cat='Binary') for e in es1 + es2 + es3}

prob += lpSum([xs[e] for e in es1])

prob += xs['sa'] == xs['av'] + xs['aw'] + xs['ax']
prob += xs['sb'] == xs['bv'] + xs['by'] + xs['bz']
prob += xs['sc'] == xs['cv'] + xs['cw']
prob += xs['sd'] == xs['dx'] + xs['dy'] + xs['dz']
prob += xs['se'] == xs['ev']
prob += xs['vt'] == xs['av'] + xs['bv'] + xs['cv'] + xs['ev']
prob += xs['wt'] == xs['aw'] + xs['cw']
prob += xs['xt'] == xs['ax'] + xs['dx']
prob += xs['yt'] == xs['by'] + xs['dy']
prob += xs['zt'] == xs['bz'] + xs['dz']

status = prob.solve()
print('Status', LpStatus[status])
for e in es2:
    print(e, xs[e].value())
print('z', prob.objective.value())

