from pulp import *

prob = LpProblem('max-flow', sense = LpMaximize)

es = ['ab', 'ac', 'bc', 'bd', 'cd', 'ce', 'de', 'df', 'ef']
ms = [5, 2, 6, 4, 2, 3, 3, 1, 9]

xs = {e: LpVariable('x{}'.format(e), lowBound=0) for e in es}
ys = {e: LpVariable('y{}'.format(e), lowBound=0) for e in es}

prob += xs['ab'] + xs['ac'] + ys['bc'] + ys['bd']

for e,m in zip(es, ms):
    prob += xs[e] + ys[e] <= m

prob += xs['ab'] == xs['bc'] + xs['bd']
prob += xs['ac'] + xs['bc'] == xs['cd'] + xs['ce']
prob += xs['bd'] + xs['cd'] == xs['de'] + xs['df']
prob += xs['ce'] + xs['de'] == xs['ab'] + xs['ac']

prob += ys['ac'] + ys['bc'] == ys['cd'] + ys['ce']
prob += ys['bd'] + ys['cd'] == ys['de'] + ys['df']
prob += ys['ce'] + ys['de'] == ys['ef']
prob += ys['df'] + ys['ef'] == ys['bc'] + ys['bd']

status = prob.solve()
print('Status', LpStatus[status])
for e in es:
    print(e, 'x =', xs[e].value(), 'y =', ys[e].value())
print('f', prob.objective.value())

