from pulp import *

prob = LpProblem('min-cost-flow')

es = ['ab', 'ac', 'bc', 'bd', 'cd', 'ce', 'de', 'df', 'ef']
ws = [5, 2, 6, 4, 2, 3, 3, 1, 9]
cs = [3, 7, 1, 2, 9, 1, 7, 8, 4]

vs = {e: LpVariable('x{}'.format(e), lowBound=0, upBound=m, cat='Integer') for e,m in zip(es,ws)}

prob += lpDot(cs, [vs[e] for e in es])

prob += vs['ab'] + vs['ac'] == 1    #6
prob += vs['ab'] == vs['bc'] + vs['bd']
prob += vs['ac'] + vs['bc'] == vs['cd'] + vs['ce']
prob += vs['bd'] + vs['cd'] == vs['de'] + vs['df']
prob += vs['ce'] + vs['de'] == vs['ef']

status = prob.solve()
print('Status', LpStatus[status])
for e in es:
    print(e, vs[e].value())
print('z', prob.objective.value())

