from pulp import *

prob = LpProblem('min-cut')

xab = LpVariable('xab', cat='Binary')
xac = LpVariable('xac', cat='Binary')
xbc = LpVariable('xbc', cat='Binary')
xbd = LpVariable('xbd', cat='Binary')
xcd = LpVariable('xcd', cat='Binary')
xce = LpVariable('xce', cat='Binary')
xde = LpVariable('xde', cat='Binary')
xdf = LpVariable('xdf', cat='Binary')
xef = LpVariable('xef', cat='Binary')

xs = [xab, xac, xbc, xbd, xcd, xce, xde, xdf, xef]
ws = [5, 2, 6, 4, 2, 3, 3, 1, 9]

va = LpVariable('va', cat='Binary')
vb = LpVariable('vb', cat='Binary')
vc = LpVariable('vc', cat='Binary')
vd = LpVariable('vd', cat='Binary')
ve = LpVariable('ve', cat='Binary')
vf = LpVariable('vf', cat='Binary')

vs = [va, vb, vc, vd, ve, vf]

prob += lpDot(ws, xs)

prob += va == 0
prob += vf == 1

prob += va - vb + xab >= 0
prob += va - vc + xac >= 0
prob += vb - vc + xbc >= 0
prob += vb - vd + xbd >= 0
prob += vc - vd + xcd >= 0
prob += vc - ve + xce >= 0
prob += vd - ve + xde >= 0
prob += vd - vf + xdf >= 0
prob += ve - vf + xef >= 0

status = prob.solve()
print('Status', LpStatus[status])
print('xab =', xab.value())
print('xac =', xac.value())
print('xbc =', xbc.value())
print('xbd =', xbd.value())
print('xcd =', xcd.value())
print('xce =', xce.value())
print('xde =', xde.value())
print('xdf =', xdf.value())
print('xef =', xef.value())
print('z', prob.objective.value())


