from pulp import *

prob = LpProblem('min-cost-flow', sense=LpMinimize)
m=3
n=10
x = [[LpVariable("x_{}_{}".format(i,j), cat='Binary') for j in range(n)] for i in range(n)]
w = [
	[3, 9, 6, 3, 2, 8, 9, 3, 2, 4],
	[8, 9, 6, 3, 5, 4, 8, 9, 2, 7],
	[3, 9, 9, 5, 9, 9, 7, 3, 3, 2],
	[7, 2, 7, 3, 8, 5, 8, 9, 3, 7],
	[3, 8, 3, 9, 4, 9, 7, 9, 8, 6]
	]
prob += lpSum([lpDot(x[i+1],w[i+1]) for i in range(m)]);
prob += lpSum([x[0][j+1] for j in range(m)]) == m
for i in range(1,n-1):
	prob += lpSum([x[j][i] for j in range(n-1)]) ==lpSum([x[i][j] for j in range(n-1)])

print(prob)

status = prob.solve()
print('Status', LpStatus[status])
for i in range(n):
  #for j in range(n):
  #  print('x_{}_{}'.format(i,j), x[i][j].value())
  print([x[i][j].value() for j in range(n)])
print('z', prob.objective.value())

