from pulp import *

prob = LpProblem('min-cost-flow', sense=LpMinimize)
m=5
n=10
x = [[LpVariable("x_{}_{}".format(i,j), cat='Binary') for j in range(n)] for i in range(m)]
w = [
	[3, 9, 6, 3, 2, 8, 9, 3, 2, 4],
	[8, 9, 6, 3, 5, 4, 8, 9, 2, 7],
	[3, 9, 9, 5, 9, 9, 7, 3, 3, 2],
	[7, 2, 7, 3, 8, 5, 8, 9, 3, 7],
	[3, 8, 3, 9, 4, 9, 7, 9, 8, 6]
	]
prob += lpSum([lpDot(x[i],w[i]) for i in range(m)]);
for i in range(m):
	prob += lpSum(x[i]) == 1
for i in range(n):
	prob += lpSum([x[j][i] for j in range(m)]) <= 1

status = prob.solve()
print('Status', LpStatus[status])
for i in range(m):
  for j in range(n):
    print('x_{}_{}'.format(i,j), x[i][j].value())
print('z', prob.objective.value())

