from pulp import *

prob = LpProblem('min-flow')

es = ['ab', 'ac', 'bc', 'bd', 'cd', 'ce', 'de', 'df', 'ef']
ms = [5, 2, 6, 4, 2, 3, 3, 1, 9]
wxs = [3, 7, 1, 2, 9, 1, 7, 8, 4]
wys = [5, 9, 3, 4, 11, 3, 9, 10, 6]

xs = {e: LpVariable('x{}'.format(e), lowBound=0) for e in es}
ys = {e: LpVariable('y{}'.format(e), lowBound=0) for e in es}

prob += lpDot(wxs, [xs[e] for e in es]) + lpDot(wys, [ys[e] for e in es])

for e,m in zip(es, ms):
    prob += xs[e] + ys[e] <= m

prob += xs['ab'] + xs['ac'] == 4
prob += xs['ab'] == xs['bc'] + xs['bd']
prob += xs['ac'] + xs['bc'] == xs['cd'] + xs['ce']
prob += xs['bd'] + xs['cd'] == xs['de'] + xs['df']
prob += xs['ce'] + xs['de'] == xs['ab'] + xs['ac']

prob += ys['bc'] + ys['bd'] == 2
prob += ys['ac'] + ys['bc'] == ys['cd'] + ys['ce']
prob += ys['bd'] + ys['cd'] == ys['de'] + ys['df']
prob += ys['ce'] + ys['de'] == ys['ef']
prob += ys['df'] + ys['ef'] == ys['bc'] + ys['bd']

status = prob.solve()
print('Status', LpStatus[status])
for e in es:
    print(e, 'x =', xs[e].value(), 'y =', ys[e].value())
print('z', prob.objective.value())


