from pulp import *
import numpy as np
import sys

BIG = 100000

prob = LpProblem(name='shortest_path', sense=LpMinimize)

nv = 5


w = [
  [ BIG,  66, 124,  25, 122],
  [  23, BIG,  15,  22,  72],
  [  11,  35, BIG,  12,  57],
  [   9,  62,  12, BIG,  47],
  [  22, 312,  26,  37, BIG]
  ]

#w = [
#  [ BIG,  23,   5,   9, 122],
#  [  23, BIG,  15,  22, 312],
#  [   5,  15, BIG,  12,  27],
#  [   9,  22,  12, BIG,  17],
#  [ 122, 312,  27,  17, BIG]
#  ]

x = [[LpVariable('{}_{}'.format(i,j), cat='Binary') for j in range(nv)] for i in range(nv)]

route = LpVariable('route')
prob += route == lpSum([lpSum([w[i][j]*x[i][j] for j in range(nv)]) for i in range(nv)])
prob += route
prob += lpSum([x[0][j] for j in range(nv)]) == 1
prob += lpSum([x[i][4] for i in range(nv)]) == 1
for i in range(nv):
  if i!=0 and i!=4:
    prob += lpSum([x[j][i] for j in range(nv)])==lpSum([x[i][j] for j in range(nv)])

print(prob)
prob.solve()
print(LpStatus[prob.status])
print('Optimal value = ', value(prob.objective))
for v in prob.variables():
  print(v.name, '=', v.varValue)

