
from pulp import *
prob = LpProblem(name='job_shop_scheduling', sense=LpMinimize)
njob = 3
p = [4,3,6]
#D = [18,8,11]
D = [8,12,10]
c = [LpVariable('s_{}'.format(i), lowBound=0, cat='Integer') for i in range(njob)]
M = 99999
x = [[LpVariable('x_{}_{}'.format(i,j), cat='Binary') for j in range(njob)] for i in range(njob)]
c = [LpVariable('c_{}'.format(i), cat='Integer') for i in range(njob)]
T = [LpVariable('T_{}'.format(i), lowBound=0, cat='Integer') for i in range(njob)]
for i in range(njob):
  prob += c[i] >= p[i]
  prob += c[i]-D[i] <= T[i]
  #prob += c[i]<=T[i]

for i in range(njob):
  for j in range(i,njob):
    if i!=j:
      prob += c[i]-c[j]+p[j] <= M * (1-x[i][j])
      prob += c[j]-c[i]+p[i] <= M * x[i][j]
      prob += x[i][j]+x[j][i]==1

prob += lpSum(T)


print(prob)
status = prob.solve()
print('Status', LpStatus[status])
print('Result')
for i in range(njob):
  print(c[i].name, c[i].value())
for i in range(njob):
  print(T[i].name, T[i].value())
for i in range(njob):
  print('D'+str(i), D[i])
print('obj', prob.objective.value())
for i in range(njob):
  for j in range(njob):
    print('x_{}_{}'.format(i,j), x[i][j].value())
