
from pulp import *
prob = LpProblem(name='job_shop_scheduling', sense=LpMinimize)
nj = 3
np = 4
p = [[4,2,3,2],[2,1,2,3],[2,4,6,3]]
s = [[LpVariable('s_{}_{}'.format(j,i), lowBound=0, cat='Integer') for i in range(np)] for j in range(nj)]
M = 99999
Cmax = LpVariable('Cmax', lowBound=0, cat='Integer')
xab = [LpVariable('xab_{}'.format(i), cat='Binary') for i in range(np)]
xac = [LpVariable('xac_{}'.format(i), cat='Binary') for i in range(np)]
xbc = [LpVariable('xbc_{}'.format(i), cat='Binary') for i in range(np)]
a_fin = LpVariable('a_fin', lowBound=0, cat='Integer')
b_fin = LpVariable('b_fin', lowBound=0, cat='Integer')
c_fin = LpVariable('c_fin', lowBound=0, cat='Integer')


for i in range(np):
  prob += s[0][i]+p[0][i]-s[1][i]<=M*(1-xab[i]), 'const_ab_{}'.format(i)
  prob += s[1][i]+p[1][i]-s[0][i]<=M*xab[i], 'const_ba_{}'.format(i)
  prob += s[0][i]+p[0][i]-s[2][i]<=M*(1-xac[i]), 'const_ac_{}'.format(i)
  prob += s[2][i]+p[2][i]-s[0][i]<=M*xac[i], 'const_ca_{}'.format(i)
  prob += s[1][i]+p[1][i]-s[2][i]<=M*(1-xbc[i]), 'const_bc_{}'.format(i)
  prob += s[2][i]+p[2][i]-s[1][i]<=M*xbc[i], 'const_cb_{}'.format(i)

#prob += Cmax >= s[0][np-1]+p[0][np-1], 'const_Cmax_a'
#prob += Cmax >= s[1][np-1]+p[1][np-1], 'const_Cmax_b'
#prob += Cmax >= s[2][np-1]+p[2][np-1], 'const_Cmax_c'

for i in range(np-1):
  prob += s[0][i]+p[0][i]<=s[0][i+1], 'const_a_{}'.format(i)
  prob += s[1][i]+p[1][i]<=s[1][i+1], 'const_b_{}'.format(i)
  prob += s[2][i]+p[2][i]<=s[2][i+1], 'const_c_{}'.format(i)

prob += a_fin == s[0][np-1] + p[0][np-1], 'const_a_fin'
prob += b_fin == s[1][np-1] + p[1][np-1], 'const_b_fin'
prob += c_fin == s[2][np-1] + p[2][np-1], 'const_c_fin'

prob += Cmax >= a_fin, 'const_Cmax_a'
prob += Cmax >= b_fin, 'const_Cmax_b'
prob += Cmax >= c_fin, 'const_Cmax_c'

prob += Cmax

print(prob)
status = prob.solve()
print('Status', LpStatus[status])
print('Result')
for i in range(nj):
  for j in range(np):
    print(s[i][j].name, s[i][j].value())
print(a_fin.name, a_fin.value())
print(b_fin.name, b_fin.value())
print(c_fin.name, c_fin.value())
print('obj', prob.objective.value())

