import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;

public class LGC extends Object
{
	public static Network net = null;
	public static IntDomain domain = null;
	public static void SetNet(Network n){ net = n; }
	public static Network GetNet(){ return net; }
	public static void SetDomain(IntDomain d){ domain = d; }
	public static IntDomain GetDomain(){ return domain; }

	public static IntVariable NOT(IntVariable x)
	{
		IntVariable not_x = new IntVariable(net, domain, "N" + x.getName());
		not_x.notEquals(x);
		return not_x;
	}
	public static IntVariable EQ(IntVariable x, IntVariable y)
	{	// same as biconditional
		IntVariable neq = new IntVariable(net, domain, "NEQ_" + x.getName() + "_" + y.getName());
		IntVariable eq = new IntVariable(net, domain, "EQ_" + x.getName() + "_" + y.getName());
		neq.equals( x.max(y).subtract(x.min(y)) );
		eq.notEquals(neq);
		return eq;
	}
	public static IntVariable NEQ(IntVariable x, IntVariable y)
	{
		IntVariable neq = new IntVariable(net, domain, "NEQ_" + x.getName() + "_" + y.getName());
		neq.equals( x.max(y).subtract(x.min(y)) );
		return neq;
	}
	public static IntVariable AND(IntVariable x, IntVariable y)
	{
		IntVariable and_xy = x.multiply(y);
		and_xy.setName("AND_" + x.getName() + "_" + y.getName());
		and_xy.setDomain(domain);
		return and_xy;
	}
	public static IntVariable OR(IntVariable x, IntVariable y)
	{
		IntVariable or12 = x.max(y);
		or12.setDomain(domain);
		or12.setName("OR_" + x.getName() + "_" + y.getName());
		return or12;
	}
	public static IntVariable IMP(IntVariable x, IntVariable y)
	{
		IntVariable imp12 = NOT(x).max(y);
		imp12.setDomain(domain);
		imp12.setName("IMP_" + x.getName() + "_" + y.getName());
		return imp12;
	}

	public static IntVariable GE(IntVariable x, int y)
	{
		IntVariable ge_var = new IntVariable(net, domain, "ge_" + x.getName() + "_" + Integer.toString(y));
		ge_var.equals( x.subtract(y).sign().add(1).sign() );
		return ge_var;
	}
	public static IntVariable GE(IntVariable x, IntVariable y)
	{
		IntVariable ge_var = new IntVariable(net, domain, "ge_" + x.getName() + "_" + y.getName());
		ge_var.equals( x.subtract(y).sign().add(1).sign() );
		return ge_var;
	}
	public static IntVariable LE(IntVariable x, int y)
	{
		IntVariable le_var = x.subtract(y).subtract(1).multiply(-1).sign();
		le_var.setDomain(domain);
		le_var.setName("le_" + x.getName() + "_" + Integer.toString(y));
		return le_var;
	}
	public static IntVariable LE(IntVariable x, IntVariable y)
	{
		IntVariable le_var = x.subtract(y).subtract(1).multiply(-1).sign();
		le_var.setDomain(domain);
		le_var.setName("le_" + x.getName() + "_" + y.getName());
		return le_var;
	}
	public static IntVariable GT(IntVariable x, int y)
	{
		IntVariable gt_var = x.subtract(y).sign().subtract(1).sign().add(1);
		gt_var.setDomain(domain);
		gt_var.setName("gt_" + x.getName() + "_" + Integer.toString(y));
		return gt_var;
	}
	public static IntVariable GT(IntVariable x, IntVariable y)
	{
		IntVariable gt_var = x.subtract(y).sign().subtract(1).sign().add(1);
		gt_var.setDomain(domain);
		gt_var.setName("gt_" + x.getName() + "_" + y.getName());
		return gt_var;

	}
	public static IntVariable LT(IntVariable x, int y)
	{
		IntVariable lt_var = x.subtract(y).multiply(-1).sign().subtract(1).sign().add(1);
		lt_var.setDomain(domain);
		lt_var.setName("lt_" + x.getName() + "_" + Integer.toString(y));
		return lt_var;
	}
	public static IntVariable LT(IntVariable x, IntVariable y)
	{
		IntVariable lt_var = x.subtract(y).multiply(-1).sign().subtract(1).sign().add(1);
		lt_var.setDomain(domain);
		lt_var.setName("lt_" + x.getName() + "_" + y.getName());
		return lt_var;
	}


	public static IntVariable NOT(IntVariable x, Network n, IntDomain d)
	{
		IntVariable not_x = new IntVariable(n, d, "N" + x.getName());
		not_x.notEquals(x);
		return not_x;
	}
}

