import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;

public class logic_test extends Object
{
	IntVariable TRUE = null;
	IntVariable FALSE = null;
	IntVariable ONE = null;
	IntVariable ZERO = null;
	IntDomain BD = null;

	public IntVariable AND(IntVariable x1, IntVariable x2)
	{
		IntVariable and12 = x1.multiply(x2);
		//IntVariable and12 = x1.min(x2);
		//and12.setName("AND_" + x1.getName() + "_" + x2.getName());
		and12.setName("A" + x1.getName() + x2.getName());
		and12.setDomain(BD);
		return and12;
	}

	public IntVariable OR(IntVariable x1, IntVariable x2)
	{
		IntVariable or12 = x1.add(x2).sign();
		//IntVariable or12 = x1.max(x2);
		//or12.setName("OR_" + x1.getName() + "_" + x2.getName());
		or12.setName("O" + x1.getName() + x2.getName());
		or12.setDomain(BD);
		return or12;
	}

	public IntVariable NOT(IntVariable x)
	{
		IntVariable not_x = x.subtract(ONE).negate();
		//not_x.setName("NOT_" + x.getName());
		not_x.setName("N" + x.getName());
		not_x.setDomain(BD);
		return not_x;
	}

	public IntVariable IMP(IntVariable x1, IntVariable x2)
	{
		IntVariable imp12 = x1.subtract(x2).subtract(ONE).abs().sign();
		//imp12.setName("IMP_" + x1.getName() + "_" + x2.getName());
		imp12.setName("I" + x1.getName() + x2.getName());
		imp12.setDomain(BD);
		return imp12;
	}

	public logic_test()
	{
		Network net = new Network();

		TRUE = new IntVariable(net, 1, "TRUE");
		FALSE = new IntVariable(net, 0, "FALSE");
		ONE = new IntVariable(net, 1, "ONE");
		ZERO = new IntVariable(net, 0, "ZERO");

		BD = new IntDomain(0,1);

		IntVariable x1 = new IntVariable(net, BD, "x1");
		IntVariable x2 = new IntVariable(net, BD, "x2");
		IntVariable not1 = NOT(x1);
		IntVariable and12 = AND(x1, x2);
		IntVariable or12 = OR(x1, x2);
		IntVariable imp12 = IMP(x1, x2);
		
		////////////
		System.out.println("Problem:");
		System.out.println(net);

		System.out.println("Solutions:");
		Solver solver = new DefaultSolver(net);
		for(solver.start(); solver.waitNext(); solver.resume()){
			Solution sol = solver.getSolution();
			System.out.println(sol);
		}
		solver.stop();
		long count = solver.getCount();
		long time = solver.getElapsedTime();

		System.out.println(count + " solutions found in " + time + " milli seconds");

	}

	public static void main(String... args)
	{
		logic_test app = new logic_test();
	}
}

