import java.io.*;
import java.util.*;
import java.util.stream.*;
import java.util.function.*;

import jp.ac.kobe_u.cs.cream.*;

public class tagiron2 extends Object
{
	public tagiron2()
	{
		Network net = new Network();

		IntVariable ZERO	= new IntVariable(net, 0, "ZERO");
		IntVariable ONE		= new IntVariable(net, 1, "ONE");
		IntVariable TWO		= new IntVariable(net, 2, "TWO");
		IntVariable THREE	= new IntVariable(net, 3, "THREE");
		IntVariable FOUR	= new IntVariable(net, 4, "FOUR");
		IntVariable FIVE	= new IntVariable(net, 5, "FIVE");
		IntVariable SIX		= new IntVariable(net, 6, "SIX");
		IntVariable SEVEN	= new IntVariable(net, 7, "SEVEN");
		IntVariable EIGHT	= new IntVariable(net, 8, "EIGHT");
		IntVariable NINE	= new IntVariable(net, 9, "NINE");

		IntVariable[] N_ary = new IntVariable[]{
			ZERO,	ZERO,
			ONE,	ONE,
			TWO,	TWO,
			THREE,	THREE,
			FOUR,	FOUR,
			FIVE,	FIVE,
			SIX,	SIX,
			SEVEN,	SEVEN,
			EIGHT,	EIGHT,
			NINE,	NINE
		};

		IntVariable RED		= new IntVariable(net, 0, "RED");
		IntVariable BLUE	= new IntVariable(net, 1, "BLUE");
		IntVariable YELLOW	= new IntVariable(net, 2, "YELLOW");
		IntVariable[] C_ary = new IntVariable[]{
			RED,	BLUE,
			RED,	BLUE,
			RED,	BLUE,
			RED,	BLUE,
			RED,	BLUE,
			YELLOW,	YELLOW,
			RED,	BLUE,
			RED,	BLUE,
			RED,	BLUE,
			RED,	BLUE
		};

		IntVariable[] ODD_ary = new IntVariable[]{
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE
		};
		IntVariable[] EVEN_ary = new IntVariable[]{
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO
		};
		IntVariable[] RED_ary = new IntVariable[]{
			ONE,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO,
			ZERO,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO,
			ONE,	ZERO
		};
		IntVariable[] BLUE_ary = new IntVariable[]{
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ZERO,
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ONE,
			ZERO,	ONE
		};
		IntVariable[] YELLOW_ary = new IntVariable[]{
			ZERO,	ZERO,
			ZERO,	ZERO,
			ZERO,	ZERO,
			ZERO,	ZERO,
			ZERO,	ZERO,
			ONE,	ONE,
			ZERO,	ZERO,
			ZERO,	ZERO,
			ZERO,	ZERO,
			ZERO,	ZERO
		};


		int n = 20;
		int m = 5;

		IntDomain num_domain = new IntDomain(0, 9);
		IntDomain c_domain = new IntDomain(0, 2);
		IntDomain BD = new IntDomain(0,1);
		IntDomain n_domain = new IntDomain(0, n);
		IntDomain m_domain = new IntDomain(0, m);
		
		LGC.SetNet(net);
		LGC.SetDomain(BD);

		
		IntVariable[] tiles = new IntVariable[n];
		for(int i=0; i<10; i++)
			for(int j=0; j<2; j++)
				tiles[2*i+j] = new IntVariable(net, 0, 1, "tile_" + Integer.toString(i) + "_" + Integer.toString(j));

		IntVariable sum_tiles = null;
		for(int i=0; i<n; i++){
			sum_tiles = sum_tiles ==null ? tiles[i] : sum_tiles.add(tiles[i]);
		}
		sum_tiles.setName("sum_tiles");
		sum_tiles.equals(2*m);

		IntVariable[][] lk_p1 = new IntVariable[m][n];
		IntVariable[][] lk_p2 = new IntVariable[m][n];
		for(int i=0; i<m; i++){
			for(int j=0; j<n; j++){
				lk_p1[i][j] = new IntVariable(net, 0, 1, "lk_p1_" + Integer.toString(i) + "_" + Integer.toString(j));
				lk_p2[i][j] = new IntVariable(net, 0, 1, "lk_p2_" + Integer.toString(i) + "_" + Integer.toString(j));
			}
		}

		for(int i=0; i<m; i++){
			for(int j=0; j<n; j++){
				lk_p1[i][j].le(tiles[j]);
				lk_p2[i][j].le(tiles[j]);
			}
		}

		for(int i=0; i<n; i++){
			for(int j=0; j<m; j++){
				for(int k=0; k<m; k++){
					if(j!=k){
						lk_p1[j][i].add(lk_p1[k][i]).le(ONE);
						lk_p2[j][i].add(lk_p2[k][i]).le(ONE);
					}
					lk_p1[j][i].add(lk_p2[k][i]).le(ONE);
				}
			}
		}

		IntVariable[] sum_lk_p1 = new IntVariable[m];
		IntVariable[] sum_lk_p2 = new IntVariable[m];
		for(int i=0; i<m; i++){
			sum_lk_p1[i] = null;
			sum_lk_p2[i] = null;
			for(int j=0; j<n; j++){
				sum_lk_p1[i] = sum_lk_p1[i]==null ? 
					lk_p1[i][j] : sum_lk_p1[i].add(lk_p1[i][j]);
				sum_lk_p2[i] = sum_lk_p2[i]==null ? 
					lk_p2[i][j] : sum_lk_p2[i].add(lk_p2[i][j]);
			}
			sum_lk_p1[i].setName("sum_lk_p1_" + Integer.toString(i));
			sum_lk_p1[i].equals(ONE);
			sum_lk_p2[i].setName("sum_lk_p2_" + Integer.toString(i));
			sum_lk_p2[i].equals(ONE);
		}

		IntVariable[] n_p1 = new IntVariable[m];
		IntVariable[] n_p2 = new IntVariable[m];
		String[] nm_n_p1 = new String[m];
		String[] nm_n_p2 = new String[m];
		for(int i=0; i<m; i++){
			n_p1[i] = null;
			n_p2[i] = null;
			for(int j=0; j<n; j++){
				n_p1[i] = n_p1[i]==null ?
					lk_p1[i][j].multiply(N_ary[j]) :
					n_p1[i].add(lk_p1[i][j].multiply(N_ary[j]));
				n_p2[i] = n_p2[i]==null ?
					lk_p2[i][j].multiply(N_ary[j]) :
					n_p2[i].add(lk_p2[i][j].multiply(N_ary[j]));
			}
			nm_n_p1[i] = "n_p1_" + Integer.toString(i);
			nm_n_p2[i] = "n_p2_" + Integer.toString(i);
			n_p1[i].setName(nm_n_p1[i]);
			n_p1[i].setDomain(num_domain);
			n_p2[i].setName(nm_n_p2[i]);
			n_p2[i].setDomain(num_domain);
		}
		for(int i=0; i<m-1; i++){
			n_p1[i].le(n_p1[i+1]);
			n_p2[i].le(n_p2[i+1]);
		}

		IntVariable[] c_p1 = new IntVariable[m];
		IntVariable[] c_p2 = new IntVariable[m];
		String[] nm_c_p1 = new String[m];
		String[] nm_c_p2 = new String[m];
		for(int i=0; i<m; i++){
			c_p1[i] = null;
			c_p2[i] = null;
			for(int j=0; j<n; j++){
				c_p1[i] = c_p1[i]==null ?
					lk_p1[i][j].multiply(C_ary[j]) :
					c_p1[i].add(lk_p1[i][j].multiply(C_ary[j]));
				c_p2[i] = c_p2[i]==null ?
					lk_p2[i][j].multiply(C_ary[j]) :
					c_p2[i].add(lk_p2[i][j].multiply(C_ary[j]));
			}
			nm_c_p1[i] = "c_p1_" + Integer.toString(i);
			nm_c_p2[i] = "c_p2_" + Integer.toString(i);
			c_p1[i].setName(nm_c_p1[i]);
			c_p1[i].setDomain(c_domain);
			c_p2[i].setName(nm_c_p2[i]);
			c_p2[i].setDomain(c_domain);
		}

		for(int i=0; i<m-1; i++){
			LGC.IMP(
				n_p1[i].subtract(FIVE).abs().sign().max(
					n_p1[i+1].subtract(FIVE).abs().sign()
				)
				,
				n_p1[i+1].subtract(n_p1[i]).sign().max(
					c_p1[i+1].subtract(c_p1[i]).sign()
				)
			).equals(ONE);
			LGC.IMP(
				n_p2[i].subtract(FIVE).abs().sign().max(
					n_p2[i+1].subtract(FIVE).abs().sign()
				)
				,
				n_p2[i+1].subtract(n_p2[i]).sign().max(
					c_p2[i+1].subtract(c_p2[i]).sign()
				)
			).equals(ONE);
		}

		String[] nms = new String[4*m];
		for(int i=0; i<m; i++){
			nms[4*i+0] = nm_n_p1[i];
			nms[4*i+1] = nm_c_p1[i];
			nms[4*i+2] = nm_n_p2[i];
			nms[4*i+3] = nm_c_p2[i];
		}

		IntVariable[] p1_map = new IntVariable[n];
		IntVariable[] p2_map = new IntVariable[n];
		for(int i=0; i<n; i++){
			p1_map[i] = null;
			p2_map[i] = null;
			for(int j=0; j<m; j++){
				p1_map[i] = p1_map[i]==null ? lk_p1[j][i] : p1_map[i].add(lk_p1[j][i]);
				p2_map[i] = p2_map[i]==null ? lk_p2[j][i] : p2_map[i].add(lk_p2[j][i]);
			}
			p1_map[i].setName("p1_map_" + Integer.toString(i));
			p1_map[i].setDomain(BD);
			p2_map[i].setName("p2_map_" + Integer.toString(i));
			p2_map[i].setDomain(BD);
		}

		// state of p1's tiles
		lk_p1[0][4].equals(ONE);
		lk_p1[1][7].equals(ONE);
		lk_p1[2][10].equals(ONE);
		lk_p1[3][14].equals(ONE);
		lk_p1[4][16].equals(ONE);

		// number of p2's odd tiles is 5
		IntVariable p2_odd_num = null;
		for(int i=0; i<n; i++){
			p2_odd_num = p2_odd_num==null ? p2_map[i].multiply(ODD_ary[i]) : p2_odd_num.add(p2_map[i].multiply(ODD_ary[i]));
		}
		p2_odd_num.setName("p2_odd_num");
		p2_odd_num.setDomain(m_domain);
		p2_odd_num.equals(FIVE);

		// number of p2's red tiles is 3
		IntVariable p2_red_num = null;
		for(int i=0; i<n; i++){
			p2_red_num = p2_red_num==null ? p2_map[i].multiply(RED_ary[i]) : p2_red_num.add(p2_map[i].multiply(RED_ary[i]));
		}
		p2_red_num.setName("p2_red_num");
		p2_red_num.setDomain(m_domain);
		p2_red_num.equals(THREE);

		// total of numbers on tiles of p2 is 21
		IntVariable n_p2_total = null;
		for(int i=0; i<n; i++){
			n_p2_total = n_p2_total==null ? p2_map[i].multiply(N_ary[i]) : n_p2_total.add(p2_map[i].multiply(N_ary[i]));
		}
		n_p2_total.setName("n_p2_total");
		n_p2_total.setDomain(new IntDomain(0,45));
		n_p2_total.equals(21);

		ArrayList<Integer[]> ret_al = SLV.SOLVE_RET(net, nms);
		ret_al.stream().forEach(ret->PrintRet(ret, nms));
		System.out.println("n:" + Integer.toString(ret_al.size()));
		
	}

	public void PrintRet(Integer[] ret, String[] nms)
	{
		int n = nms.length/4;
		Integer[] p1_n = new Integer[n];
		Integer[] p1_c = new Integer[n];
		Integer[] p2_n = new Integer[n];
		Integer[] p2_c = new Integer[n];
		String[] p1_str = new String[n];
		String[] p2_str = new String[n];

		for(int i=0; i<n; i++){
			p1_n[i] = ret[4*i+0];
			p1_c[i] = ret[4*i+1];
			p2_n[i] = ret[4*i+2];
			p2_c[i] = ret[4*i+3];
		
			p1_str[i] = "(" + p1_n[i].toString() + "," + p1_c[i].toString() + ")";
			p2_str[i] = "(" + p2_n[i].toString() + "," + p2_c[i].toString() + ")";
		}
		System.out.println(
			String.join("", p1_str) + "-" + String.join("", p2_str)
		);
	}

	public static void main(String... args)
	{
		tagiron2 app = new tagiron2();
	}

}

